/*
        Copyright (c) 1996, NeXT Software, Inc.
        All rights reserved.

        You may freely copy, distribute and reuse the code in this example.
        NeXT disclaims any warranty of any kind, expressed or implied,
        as to its fitness for any particular use.
*/
#import <EOAccess/EOAccess.h>

#define databaseNameKey           	@"databaseName"
#define hostNameKey    				@"hostName"

// Sun Mar 30 03:14:33 MET DST 1997 	dave@turbocat.de
// PG uses Sun Mar 30 01:26:50 1997 MET
#define PostgreSQLCalendarFormat @"%a %b %d %H:%M:%S %Y %Z"

@interface PostgreSQLAdaptor:EOAdaptor
{
}

+ (NSDictionary *)defaultConnectionDictionary;

- initWithName:(NSString *)name;
- (Class)expressionClass;
- (EOAdaptorContext *)createAdaptorContext;
- (BOOL)isValidQualifierType:(NSString *)typeName model:(EOModel *)model;
- (void)assertConnectionDictionaryIsValid;

@end

@interface PostgreSQLAdaptor (ExternalTypeMapping)

+ (NSString *)defaultExternalType;
+ (NSDictionary *)externalToInternalTypeMap;
+ (NSString *)internalTypeForExternalType:(NSString *)extType model:(EOModel *)model;
+ (NSArray *)externalTypesWithModel:(EOModel *)model;
+ (void)assignExternalInfoForAttribute:(EOAttribute *)attribute;
+ (void)assignExternalInfoForEntity:(EOEntity *)entity;
+ (void)assignExternalInfoForEntireModel:(EOModel *)model;

@end
