/*
        Copyright (c) 1996, NeXT Software, Inc.
        All rights reserved.

        You may freely copy, distribute and reuse the code in this example.
        NeXT disclaims any warranty of any kind, expressed or implied,
        as to its fitness for any particular use.
*/
#import <EOAccess/EOAccess.h>
#import <PostgreSQL/libpq-fe.h>

@class PostgreSQLAdaptor;
@class PostgreSQLChannel;

#define ColumnNameKey @"name"
#define ColumnTypeKey @"type"

@interface PostgreSQLContext:EOAdaptorContext
{
    NSMutableDictionary *tableNameToInfoMap;
    NSMutableSet *dirtyTables;
    BOOL didAutoBegin;
	// dave@turbocat.de for postgres
  	//PGconn* conn;
  	//PGresult* res;
}

- initWithPostgreSQLAdaptor:(PostgreSQLAdaptor *)adaptor;
- (void)dealloc;
- (EOAdaptorChannel *)createAdaptorChannel;
- (void)beginTransaction;
- (void)commitTransaction;
- (void)rollbackTransaction;
- (BOOL)canNestTransactions;

//- (NSString *)path;
//- (NSString *)rowSeparator;
//- (NSString *)columnSeparator;
//- (BOOL)useColumnHeaders;

- (NSMutableData *)dataForTable:(NSString *)tableName;
- (NSArray *)columnInfosForTable:(NSString *)tableName;
//- (NSDictionary *)columnIndexMapForTable:(NSString *)tableName;
- (void)channel:(PostgreSQLChannel *)channel didDirtyTable:(NSString *)tableName;

- (BOOL)autoBeginTransaction;
- (BOOL)autoCommitTransaction;

@end
